/*
Copyright (C) 2006 - 2009 Evan Teran
                   eteran@alum.rit.edu

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
*/

#include "ELFBinaryInfo.h"
#include "ELF32.h"
#include "ELF64.h"
#include "BinaryInfo.h"
#include "Debugger.h"

namespace {
	BinaryInfo *InfoCreate32(const MemRegion &region) {
		return new ELF32(region);
	}

	BinaryInfo *InfoCreate64(const MemRegion &region) {
		return new ELF64(region);
	}
}

//------------------------------------------------------------------------------
// Name: ELFBinaryInfo()
// Desc: 
//------------------------------------------------------------------------------
ELFBinaryInfo::ELFBinaryInfo() {
}

//------------------------------------------------------------------------------
// Name: ELFBinaryInfo()
// Desc: 
//------------------------------------------------------------------------------
void ELFBinaryInfo::privateInit() {
	edb::v1::registerBinaryInfo(InfoCreate32);
	edb::v1::registerBinaryInfo(InfoCreate64);
}

//------------------------------------------------------------------------------
// Name: menu(QWidget *parent)
// Desc: 
//------------------------------------------------------------------------------
QMenu *ELFBinaryInfo::menu(QWidget *parent) {
	Q_UNUSED(parent);
	return 0;
}

Q_EXPORT_PLUGIN2(ELFBinaryInfo, ELFBinaryInfo)
